"""
@Author = 'Michael Stanley'

============ Change Log ============
01/12/2023 = Created.

============ License ============
Copyright (C) 2023 Michael Stanley

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
"""
import pytest
from wmul_test_utils import assert_has_only_these_calls


def test_call_counts_dont_match(mocker):
    mock_under_test = mocker.Mock()
    mock_under_test(1)
    mock_under_test(2)
    mock_under_test(3)

    expected_calls = [
        mocker.call(1),
        mocker.call(2)
    ]

    with pytest.raises(AssertionError) as ae:
        assert_has_only_these_calls(mock_under_test, expected_calls)


def test_call_counts_match(mocker):
    mock_under_test = mocker.Mock()
    mock_under_test(1)
    mock_under_test(2)

    expected_calls = [
        mocker.call(1),
        mocker.call(2)
    ]

    assert_has_only_these_calls(mock_under_test, expected_calls)
